Results 1 to 4 of 4

Thread: Multileader

  1. #1
    Wish List Administration
    Join Date
    2011-08
    Posts
    4,581

    Default Re: Multileader

    Summary: Multileader Rotate to match to DView TWist

    Description: To use Multileaders in Civil 3D has always required purchasing software like Sincpac-C3D. With all the years this command has been around why hasn't this command been modified to work in the Civil 3D we already paid for yet? https://forums.autodesk.com/t5/civil-3d-forum/snap-mode-settings/m-p/6444054#M306975

    Product and Feature: AutoCAD Civil 3D - Other

    Submitted By: Tom Beauford on 08/29/2020


  2. #2
    Certifiable AUGI Addict
    Join Date
    2001-03
    Location
    Tallahassee, FL USA
    Posts
    3,665

    Default Re: Multileader

    Lisp patched together from others for drawing a Multileader whose Rotation matches the DView TWist angle for Civil drawings.
    Code:
    ;| Modified code from danglar & Kent1Cooper
    https://forums.autodesk.com/t5/visual-lisp-autolisp-and-general/rotating-leader-to-current-view/m-p/6934473#M350902
    ^P(if(not C:MultileaderHoriz)(load "MultileaderHoriz.lsp"));MultileaderHoriz
    (load "MultileaderHoriz.lsp");MultileaderHoriz
    (defun c:zzr () (c:MultileaderHoriz)) ; Create Horizontal Multileader with Text aligned Horizontally |;
    (defun c:MultileaderHoriz (/ *error* snapang AT:UCSAngle ang ss name ldr pts23 base refang)
    
      (defun *error* (msg)
        (command-s "UCS" "World")
        (setvar "snapang" snapang)
    ;    (setvar "snapang" (- (getvar "viewtwist")))
        (and *AcadDoc* (vla-endundomark *AcadDoc*))
        (setvar 'CMDECHO 1)
        (if (and msg (not (wcmatch (strcase msg) "*BREAK*,*CANCEL*,*QUIT*,")))
          (princ (strcat "\nError: " msg))
        )
      )
    
      (defun AT:UCSAngle (/) ; Return current UCS angle by Alan J. Thompson, 04.06.10
        ((lambda (x) (atan (cadr x) (car x))) (trans (getvar 'UCSXDIR) 0 (trans '(0. 0. 1.) 1 0 T) T))
      )
    
      (vl-load-com)
    
      (vla-startundomark
        (cond (*AcadDoc*)
              ((setq *AcadDoc* (vla-get-activedocument (vlax-get-acad-object))))
        )
      )
      (setvar 'CMDECHO 0)
      (setq snapang (getvar "snapang"))
     (command "UCS" "View")
     (setvar "snapang" (- snapang (AT:UCSAngle)))
    ; (setvar "snapang" 0.0)
     (command-s "MLEADER")
      (*error* nil)
      (princ)
    )
    ;

  3. #3
    Administrator Opie's Avatar
    Join Date
    2002-01
    Location
    jUSt Here (a lot)
    Posts
    9,100

    Default Re: Multileader

    Changing the UCS to match the VIEW of the viewport works just fine without the need to purchase any add-ons. Although, SincPac may have additional features that assist with Civil 3D drafting.
    If you have a technical question, please find the appropriate forum and ask it there.
    You will get a quicker response from your fellow AUGI members than if you sent it to me via a PM or email.
    jUSt

  4. #4
    Certifiable AUGI Addict
    Join Date
    2001-03
    Location
    Tallahassee, FL USA
    Posts
    3,665

    Default Re: Multileader

    Quote Originally Posted by Opie View Post
    Changing the UCS to match the VIEW of the viewport works just fine without the need to purchase any add-ons. Although, SincPac may have additional features that assist with Civil 3D drafting.
    Don't own the SincPac software but the posted lisp does draw the Multileader with the UCS set to View and ensures it's set back to World that Civil 3D functions require. As annotative text, dimensions, and blocks align horizontally just like Civil 3D labels it sure would be nice if annotative Multileaders worked the same as they did.

Posting Permissions

  • You may not post new threads
  • You may not post replies
  • You may not post attachments
  • You may not edit your posts
  •